module.exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = "./src/index.ts");
/******/ })
/************************************************************************/
/******/ ({

/***/ "./src/AdvancedLogger.ts":
/*!*******************************!*\
  !*** ./src/AdvancedLogger.ts ***!
  \*******************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return AdvancedLogger; });
/* harmony import */ var _babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @babel/runtime/helpers/defineProperty */ "@babel/runtime/helpers/defineProperty");
/* harmony import */ var _babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _LogStore__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./LogStore */ "./src/LogStore.ts");


/**
 * Uses different strategies to submit logs to log server via Service facade.
 */

class AdvancedLogger {
  constructor(configuration) {
    _babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_0___default()(this, "configuration", void 0);

    _babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_0___default()(this, "strategy", void 0);

    _babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_0___default()(this, "service", void 0);

    _babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_0___default()(this, "logStore", void 0);

    this.configuration = configuration;
    this.logStore = new _LogStore__WEBPACK_IMPORTED_MODULE_1__["default"]({
      transformations: this.configuration.transformations
    });
    this.strategy = this.configuration.strategy;
    this.service = this.configuration.service; // todo Where is it better to subscribe?

    this.logStore.eventEmitter.on("add", this.onAdd.bind(this));
    this.logStore.eventEmitter.on("clear", this.onClear.bind(this));
    this.logStore.eventEmitter.on("error", this.onStoreError.bind(this));
    this.strategy.eventEmitter.on("send", this.onSend.bind(this));
    this.strategy.eventEmitter.on("error", this.onStrategyError.bind(this));
  }

  log(log) {
    this.logStore.add(log);
  }
  /**
   * Forces strategy to initiate logs sending
   */


  sendAllLogs() {
    this.strategy.sendAll();
  }

  destroy() {
    this.logStore.destroy();
    this.logStore = null;
    this.strategy.destroy();
    this.strategy = null;
    this.service.destroy();
    this.service = null;
    this.configuration = null;
  }

  onStoreError(error) {
    console.error(error);
  }

  onAdd(info) {
    this.strategy.onAdd(info);
  }

  onClear() {
    this.strategy.onClear();
  }

  onStrategyError(error) {
    console.error(error);
  }

  onSend() {
    if (this.logStore.size() > 0) {
      const logs = this.logStore.getAll(); // We need to clear store as soon as we received request to send all logs

      this.logStore.clear();
      this.service.sendAllLogs(logs).catch(error => console.error(error));
    }
  }

}

/***/ }),

/***/ "./src/LogStore.ts":
/*!*************************!*\
  !*** ./src/LogStore.ts ***!
  \*************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return LogStore; });
/* harmony import */ var _babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @babel/runtime/helpers/defineProperty */ "@babel/runtime/helpers/defineProperty");
/* harmony import */ var _babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var events__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! events */ "events");
/* harmony import */ var events__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(events__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var lodash_throttle__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! lodash/throttle */ "lodash/throttle");
/* harmony import */ var lodash_throttle__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(lodash_throttle__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _enums_TransformationEnum__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./enums/TransformationEnum */ "./src/enums/TransformationEnum.ts");
/* harmony import */ var _util_LogUtils__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./util/LogUtils */ "./src/util/LogUtils.ts");





class LogStore {
  /**
   * Subscribe in order to receive "add", "cleared" events
   */
  // todo Proper typing for method is needed
  constructor(config) {
    _babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_0___default()(this, "eventEmitter", void 0);

    _babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_0___default()(this, "logs", void 0);

    _babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_0___default()(this, "config", void 0);

    _babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_0___default()(this, "identityMap", void 0);

    _babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_0___default()(this, "groupLeftIndex", -1);

    _babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_0___default()(this, "groupableConfig", void 0);

    _babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_0___default()(this, "throttledOnGroupFinalize", void 0);

    this.logs = [];
    this.eventEmitter = new events__WEBPACK_IMPORTED_MODULE_1__["EventEmitter"]();
    this.config = config;
    this.initTransformations();
  }

  add(log) {
    if (this.groupableConfig) {
      const id = _util_LogUtils__WEBPACK_IMPORTED_MODULE_4__["default"].getLogIdByFields(log, this.groupableConfig.groupIdentityFields);

      if (!this.identityMap.has(id)) {
        this.logs.push(log);
      }

      this.onAddToGroup(log);
    } else {
      this.logs.push(log);
    }

    this.eventEmitter.emit("add", {
      logCount: this.size()
    });
  }

  clear() {
    this.logs.length = 0;
    this.eventEmitter.emit("clear");
  }

  getAll() {
    if (this.throttledOnGroupFinalize) {
      this.throttledOnGroupFinalize.flush();
    }

    return this.logs.slice();
  }

  size() {
    return this.logs.length;
  }

  destroy() {
    if (this.throttledOnGroupFinalize) {
      this.throttledOnGroupFinalize.cancel();
    }

    this.logs.length = 0;
    this.eventEmitter.removeAllListeners();
    this.eventEmitter = null;
  } //todo Should it be moved to a separate class? Come up with a nicer design


  initTransformations() {
    if (this.config.transformations) {
      const groupableConfig = this.config.transformations.find(value => value.type === _enums_TransformationEnum__WEBPACK_IMPORTED_MODULE_3__["TransformationEnum"].RAPID_FIRE_GROUPING);

      if (groupableConfig) {
        this.groupableConfig = groupableConfig.configuration;
        this.identityMap = new Map();
        this.throttledOnGroupFinalize = lodash_throttle__WEBPACK_IMPORTED_MODULE_2___default()(this.onGroupFinalize.bind(this), this.groupableConfig.interval, {
          trailing: true,
          leading: false
        }); //todo Maybe, move to add method

        this.eventEmitter.on("add", this.throttledOnGroupFinalize);
      }
    }
  }

  onAddToGroup(log) {
    const logId = _util_LogUtils__WEBPACK_IMPORTED_MODULE_4__["default"].getLogIdByFields(log, this.groupableConfig.groupIdentityFields);

    if (this.identityMap.has(logId)) {
      const savedCounter = this.identityMap.get(logId);
      this.identityMap.set(logId, savedCounter + 1);
    } else {
      this.identityMap.set(logId, 1);
    }
  }

  onGroupFinalize() {
    // Apply grouping counters from Map to logs range from left index to the last
    const len = this.logs.length;

    if (len > 0) {
      for (let i = this.groupLeftIndex !== -1 ? this.groupLeftIndex : 0; i < len; i++) {
        const log = this.logs[i];
        const id = _util_LogUtils__WEBPACK_IMPORTED_MODULE_4__["default"].getLogIdByFields(log, this.groupableConfig.groupIdentityFields);
        log[this.groupableConfig.groupFieldName] = this.identityMap.has(id) ? this.identityMap.get(id) : 1;
      }
    }

    this.groupLeftIndex = len > 0 ? len - 1 : -1;
    this.identityMap.clear();
  }

}

/***/ }),

/***/ "./src/enums/TransformationEnum.ts":
/*!*****************************************!*\
  !*** ./src/enums/TransformationEnum.ts ***!
  \*****************************************/
/*! exports provided: TransformationEnum */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "TransformationEnum", function() { return TransformationEnum; });
let TransformationEnum;

(function (TransformationEnum) {
  TransformationEnum[TransformationEnum["RAPID_FIRE_GROUPING"] = 0] = "RAPID_FIRE_GROUPING";
})(TransformationEnum || (TransformationEnum = {}));

/***/ }),

/***/ "./src/index.ts":
/*!**********************!*\
  !*** ./src/index.ts ***!
  \**********************/
/*! exports provided: AdvancedLogger, strategy, service, TransformationEnum */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "strategy", function() { return strategy; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "service", function() { return service; });
/* harmony import */ var _AdvancedLogger__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./AdvancedLogger */ "./src/AdvancedLogger.ts");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "AdvancedLogger", function() { return _AdvancedLogger__WEBPACK_IMPORTED_MODULE_0__["default"]; });

/* harmony import */ var _enums_TransformationEnum__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./enums/TransformationEnum */ "./src/enums/TransformationEnum.ts");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "TransformationEnum", function() { return _enums_TransformationEnum__WEBPACK_IMPORTED_MODULE_1__["TransformationEnum"]; });

/* harmony import */ var _service_ConsoleService__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./service/ConsoleService */ "./src/service/ConsoleService.ts");
/* harmony import */ var _service_ElasticsearchService__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./service/ElasticsearchService */ "./src/service/ElasticsearchService.ts");
/* harmony import */ var _service_LogglyService__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./service/LogglyService */ "./src/service/LogglyService.ts");
/* harmony import */ var _service_SumologicService__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./service/SumologicService */ "./src/service/SumologicService.ts");
/* harmony import */ var _strategy_InstantStrategy__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./strategy/InstantStrategy */ "./src/strategy/InstantStrategy.ts");
/* harmony import */ var _strategy_OnBundleSizeStrategy__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./strategy/OnBundleSizeStrategy */ "./src/strategy/OnBundleSizeStrategy.ts");
/* harmony import */ var _strategy_OnIntervalStrategy__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./strategy/OnIntervalStrategy */ "./src/strategy/OnIntervalStrategy.ts");
/* harmony import */ var _strategy_OnRequestStrategy__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ./strategy/OnRequestStrategy */ "./src/strategy/OnRequestStrategy.ts");










const strategy = {
  InstantStrategy: _strategy_InstantStrategy__WEBPACK_IMPORTED_MODULE_6__["default"],
  OnBundleSizeStrategy: _strategy_OnBundleSizeStrategy__WEBPACK_IMPORTED_MODULE_7__["default"],
  OnRequestStrategy: _strategy_OnRequestStrategy__WEBPACK_IMPORTED_MODULE_9__["default"],
  OnIntervalStrategy: _strategy_OnIntervalStrategy__WEBPACK_IMPORTED_MODULE_8__["default"]
};
const service = {
  SumologicService: _service_SumologicService__WEBPACK_IMPORTED_MODULE_5__["default"],
  LogglyService: _service_LogglyService__WEBPACK_IMPORTED_MODULE_4__["default"],
  ConsoleService: _service_ConsoleService__WEBPACK_IMPORTED_MODULE_2__["default"],
  ElasticsearchService: _service_ElasticsearchService__WEBPACK_IMPORTED_MODULE_3__["default"]
};


/***/ }),

/***/ "./src/service/BaseRemoteService.ts":
/*!******************************************!*\
  !*** ./src/service/BaseRemoteService.ts ***!
  \******************************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return BaseRemoteService; });
/* harmony import */ var core_js_modules_es_promise__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! core-js/modules/es.promise */ "core-js/modules/es.promise");
/* harmony import */ var core_js_modules_es_promise__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(core_js_modules_es_promise__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @babel/runtime/helpers/defineProperty */ "@babel/runtime/helpers/defineProperty");
/* harmony import */ var _babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var fast_safe_stringify__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! fast-safe-stringify */ "fast-safe-stringify");
/* harmony import */ var fast_safe_stringify__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(fast_safe_stringify__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _util_http__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../util/http */ "./src/util/http.ts");
/* harmony import */ var _util_LogUtils__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../util/LogUtils */ "./src/util/LogUtils.ts");





class BaseRemoteService {
  constructor(config) {
    _babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_1___default()(this, "serviceConfig", void 0);

    _babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_1___default()(this, "defaultLogConfig", void 0);

    this.serviceConfig = { ...config.serviceConfig
    };
    this.defaultLogConfig = { ...config.defaultLogConfig
    }; // optional serializer override

    if (config.serializer) {
      this.serializer = config.serializer;
    }
  }

  serializer(log) {
    return _util_LogUtils__WEBPACK_IMPORTED_MODULE_4__["default"].tryJSONStringify(log) || fast_safe_stringify__WEBPACK_IMPORTED_MODULE_2___default()(log);
  }

  sendAllLogs(logs) {
    return this.preparePayload(logs).then(payload => {
      const headers = this.getHeaders();

      if (this.serviceConfig.retryAttempts && this.serviceConfig.retryAttempts > 0) {
        return _util_http__WEBPACK_IMPORTED_MODULE_3__["default"].postRequest(this.serviceConfig, headers, payload).catch(() => _util_http__WEBPACK_IMPORTED_MODULE_3__["default"].delayedRetry(this.serviceConfig.retryAttempts, this.serviceConfig.retryInterval, _util_http__WEBPACK_IMPORTED_MODULE_3__["default"].postRequest.bind(this, this.serviceConfig, headers, payload)));
      } else {
        return _util_http__WEBPACK_IMPORTED_MODULE_3__["default"].postRequest(this.serviceConfig, headers, payload);
      }
    });
  }

  preparePayload(logs) {
    const resultList = logs.map(log => this.serializer({ ...this.defaultLogConfig,
      ...log
    }));
    return Promise.resolve(resultList.join("\n"));
  }

  destroy() {
    this.serviceConfig = null;
    this.defaultLogConfig = null;
  }
  /**
   * Returns object for headers config
   * @example
   * {"Content-Type": "text/plain"}
   */


  getHeaders() {
    return {};
  }

}

/***/ }),

/***/ "./src/service/ConsoleService.ts":
/*!***************************************!*\
  !*** ./src/service/ConsoleService.ts ***!
  \***************************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return ConsoleService; });
/* harmony import */ var core_js_modules_es_promise__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! core-js/modules/es.promise */ "core-js/modules/es.promise");
/* harmony import */ var core_js_modules_es_promise__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(core_js_modules_es_promise__WEBPACK_IMPORTED_MODULE_0__);


/**
 * Console reporting service for debugging purposes
 */
class ConsoleService {
  preparePayload(logs) {
    return Promise.resolve(logs.map(log => this.serializer(log)));
  }

  sendAllLogs(logs) {
    console.log(logs);
    return Promise.resolve();
  }

  destroy() {//nothing to do here
  }

  serializer(log) {
    return log;
  }

}

/***/ }),

/***/ "./src/service/ElasticsearchService.ts":
/*!*********************************************!*\
  !*** ./src/service/ElasticsearchService.ts ***!
  \*********************************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return ElasticsearchService; });
/* harmony import */ var core_js_modules_es_promise__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! core-js/modules/es.promise */ "core-js/modules/es.promise");
/* harmony import */ var core_js_modules_es_promise__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(core_js_modules_es_promise__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _BaseRemoteService__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./BaseRemoteService */ "./src/service/BaseRemoteService.ts");


const DEFAULT_INDEX_FIELD = "Index";
const DEFAULT_INDEX_VALUE = "index";
class ElasticsearchService extends _BaseRemoteService__WEBPACK_IMPORTED_MODULE_1__["default"] {
  preparePayload(logs) {
    const resultList = [];
    logs.forEach(log => {
      const finalLog = { ...this.defaultLogConfig,
        ...log
      };
      resultList.push(this.serializer(this.getLogMetaConfig(finalLog[this.serviceConfig.logMetaIndexField || DEFAULT_INDEX_FIELD])));
      resultList.push(this.serializer(finalLog));
    });
    return Promise.resolve(`${resultList.join("\n")}\n`);
  }

  getHeaders() {
    return {
      "Content-Type": "application/json"
    };
  }

  getLogMetaConfig(index) {
    return {
      index: {
        _index: index || DEFAULT_INDEX_VALUE,
        _type: "_doc"
      }
    };
  }

}

/***/ }),

/***/ "./src/service/LogglyService.ts":
/*!**************************************!*\
  !*** ./src/service/LogglyService.ts ***!
  \**************************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return LogglyService; });
/* harmony import */ var _BaseRemoteService__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./BaseRemoteService */ "./src/service/BaseRemoteService.ts");

class LogglyService extends _BaseRemoteService__WEBPACK_IMPORTED_MODULE_0__["default"] {
  getHeaders() {
    return {
      "Content-Type": "text/plain"
    };
  }

}

/***/ }),

/***/ "./src/service/SumologicService.ts":
/*!*****************************************!*\
  !*** ./src/service/SumologicService.ts ***!
  \*****************************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return SumologicService; });
/* harmony import */ var _BaseRemoteService__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./BaseRemoteService */ "./src/service/BaseRemoteService.ts");

class SumologicService extends _BaseRemoteService__WEBPACK_IMPORTED_MODULE_0__["default"] {
  getHeaders() {
    const serviceConfig = this.serviceConfig;
    return {
      "Content-Type": "application/json",
      //todo Optional?
      "X-Sumo-Category": serviceConfig.sourceCategory,
      //todo Optional?
      "X-Sumo-Host": serviceConfig.host,
      //todo Optional?
      "X-Sumo-Name": serviceConfig.sourceName
    };
  }

}

/***/ }),

/***/ "./src/strategy/InstantStrategy.ts":
/*!*****************************************!*\
  !*** ./src/strategy/InstantStrategy.ts ***!
  \*****************************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return InstantStrategy; });
/* harmony import */ var _babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @babel/runtime/helpers/defineProperty */ "@babel/runtime/helpers/defineProperty");
/* harmony import */ var _babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var events__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! events */ "events");
/* harmony import */ var events__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(events__WEBPACK_IMPORTED_MODULE_1__);


class InstantStrategy {
  constructor() {
    _babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_0___default()(this, "eventEmitter", void 0);

    this.eventEmitter = new events__WEBPACK_IMPORTED_MODULE_1__["EventEmitter"]();
  }

  onAdd(info) {
    this.eventEmitter.emit("send"); //console.log("InstantStrategy#sent");
  }

  onClear() {// Ignore log list change
    //console.log("InstantStrategy#cleared");
  }

  sendAll() {// This strategy sends all logs separately
  }

  destroy() {
    this.eventEmitter.removeAllListeners();
    this.eventEmitter = null;
  }

}

/***/ }),

/***/ "./src/strategy/OnBundleSizeStrategy.ts":
/*!**********************************************!*\
  !*** ./src/strategy/OnBundleSizeStrategy.ts ***!
  \**********************************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return OnBundleSizeStrategy; });
/* harmony import */ var _babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @babel/runtime/helpers/defineProperty */ "@babel/runtime/helpers/defineProperty");
/* harmony import */ var _babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var events__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! events */ "events");
/* harmony import */ var events__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(events__WEBPACK_IMPORTED_MODULE_1__);


class OnBundleSizeStrategy {
  /**
   * @type {number}
   */
  constructor(config) {
    _babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_0___default()(this, "eventEmitter", void 0);

    _babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_0___default()(this, "MAX_BUNDLE_SIZE", 100);

    this.eventEmitter = new events__WEBPACK_IMPORTED_MODULE_1__["EventEmitter"]();

    if (config.maxBundle) {
      this.MAX_BUNDLE_SIZE = config.maxBundle;
    }
  }

  onAdd(info) {
    if (info && info.logCount >= this.MAX_BUNDLE_SIZE) {
      this.eventEmitter.emit("send");
    } else {//console.log("Not enough logs so far");
    }
  }

  onClear() {// Ignore log list change
    //console.log("OnBundleSizeStrategy#cleared");
  }

  sendAll() {
    this.eventEmitter.emit("send");
  }

  destroy() {
    this.eventEmitter.removeAllListeners();
    this.eventEmitter = null;
  }

}

/***/ }),

/***/ "./src/strategy/OnIntervalStrategy.ts":
/*!********************************************!*\
  !*** ./src/strategy/OnIntervalStrategy.ts ***!
  \********************************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return OnIntervalStrategy; });
/* harmony import */ var _babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @babel/runtime/helpers/defineProperty */ "@babel/runtime/helpers/defineProperty");
/* harmony import */ var _babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var events__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! events */ "events");
/* harmony import */ var events__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(events__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var lodash_throttle__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! lodash/throttle */ "lodash/throttle");
/* harmony import */ var lodash_throttle__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(lodash_throttle__WEBPACK_IMPORTED_MODULE_2__);



class OnIntervalStrategy {
  constructor(config) {
    _babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_0___default()(this, "eventEmitter", void 0);

    _babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_0___default()(this, "SEND_INTERVAL", 15000);

    _babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_0___default()(this, "intervalSend", void 0);

    this.eventEmitter = new events__WEBPACK_IMPORTED_MODULE_1__["EventEmitter"]();

    if (config.interval) {
      this.SEND_INTERVAL = config.interval;
    }

    this.intervalSend = lodash_throttle__WEBPACK_IMPORTED_MODULE_2___default()(this.send.bind(this), this.SEND_INTERVAL, {
      leading: false,
      trailing: true
    });
  }

  onAdd(info) {
    if (info && info.logCount > 0) {
      this.intervalSend();
    }
  }

  onClear() {// Ignore log list change
    //console.log("OnIntervalStrategy#cleared");
  }

  sendAll() {
    this.eventEmitter.emit("send");
  }

  destroy() {
    this.eventEmitter.removeAllListeners();
    this.eventEmitter = null;
  }

  send() {
    this.eventEmitter.emit("send");
  }

}

/***/ }),

/***/ "./src/strategy/OnRequestStrategy.ts":
/*!*******************************************!*\
  !*** ./src/strategy/OnRequestStrategy.ts ***!
  \*******************************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return OnRequestStrategy; });
/* harmony import */ var _babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @babel/runtime/helpers/defineProperty */ "@babel/runtime/helpers/defineProperty");
/* harmony import */ var _babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var events__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! events */ "events");
/* harmony import */ var events__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(events__WEBPACK_IMPORTED_MODULE_1__);


class OnRequestStrategy {
  constructor() {
    _babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_0___default()(this, "eventEmitter", void 0);

    this.eventEmitter = new events__WEBPACK_IMPORTED_MODULE_1__["EventEmitter"]();
  }

  onAdd(info) {// Ignore log list change
  }

  onClear() {// Ignore log list change
    //console.log("OnRequestStrategy#cleared");
  }

  sendAll() {
    this.eventEmitter.emit("send");
  }

  destroy() {
    this.eventEmitter.removeAllListeners();
    this.eventEmitter = null;
  }

}

/***/ }),

/***/ "./src/util/LogUtils.ts":
/*!******************************!*\
  !*** ./src/util/LogUtils.ts ***!
  \******************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
const DELIMETER = "-";
/* harmony default export */ __webpack_exports__["default"] = ({
  getLogIdByFields(log, fields) {
    return fields.map(field => `${field}${DELIMETER}${log[field]}`).join(DELIMETER);
  },

  /**
   * It is necessary to convert objects safely, otherwise we can lost the whole log bundle
   */
  tryJSONStringify(obj) {
    try {
      return JSON.stringify(obj);
    } catch (_) {
      //ignore the error
      return "";
    }
  }

});

/***/ }),

/***/ "./src/util/http.ts":
/*!**************************!*\
  !*** ./src/util/http.ts ***!
  \**************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var core_js_modules_es_promise__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! core-js/modules/es.promise */ "core-js/modules/es.promise");
/* harmony import */ var core_js_modules_es_promise__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(core_js_modules_es_promise__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var node_fetch__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! node-fetch */ "node-fetch");
/* harmony import */ var node_fetch__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(node_fetch__WEBPACK_IMPORTED_MODULE_1__);


const http = {
  postRequest(serviceConfig, headers, payload) {
    return node_fetch__WEBPACK_IMPORTED_MODULE_1___default()(serviceConfig.url, {
      method: serviceConfig.method,
      body: payload,
      headers
    });
  },

  delayedRetry(retries, delay = 0, fn) {
    return new Promise((resolve, reject) => {
      setTimeout(() => fn().then(resolve).catch(reject), delay);
    }).catch(error => retries > 1 ? http.delayedRetry(retries - 1, delay, fn) : Promise.reject(error));
  }

};
/* harmony default export */ __webpack_exports__["default"] = (http);

/***/ }),

/***/ "@babel/runtime/helpers/defineProperty":
/*!********************************************************!*\
  !*** external "@babel/runtime/helpers/defineProperty" ***!
  \********************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("@babel/runtime/helpers/defineProperty");

/***/ }),

/***/ "core-js/modules/es.promise":
/*!*********************************************!*\
  !*** external "core-js/modules/es.promise" ***!
  \*********************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("core-js/modules/es.promise");

/***/ }),

/***/ "events":
/*!*************************!*\
  !*** external "events" ***!
  \*************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("events");

/***/ }),

/***/ "fast-safe-stringify":
/*!**************************************!*\
  !*** external "fast-safe-stringify" ***!
  \**************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("fast-safe-stringify");

/***/ }),

/***/ "lodash/throttle":
/*!**********************************!*\
  !*** external "lodash/throttle" ***!
  \**********************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("lodash/throttle");

/***/ }),

/***/ "node-fetch":
/*!*****************************!*\
  !*** external "node-fetch" ***!
  \*****************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("node-fetch");

/***/ })

/******/ });
//# sourceMappingURL=advanced-logger.node.js.map